## deepin-terminal 3.0.3+ds

=== CMakeLists.txt ===
project("dterminal" C)

set(target deepin-terminal)

cmake_minimum_required(VERSION 2.6)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(ExternalProject)
include(ValaPrecompile)
include(ValaVersion)
find_package(Vala)
ensure_vala_version("0.22.0" MINIMUM)
find_package(PkgConfig)
find_package(GLib "2.48" REQUIRED)
find_package(JsonGlib)
find_package(Libsecret)
find_package(FontConfig)
find_package(X11)
find_package(Gettext)

pkg_check_modules(GTK3 REQUIRED gtk+-3.0)
pkg_check_modules(GEE REQUIRED gee-0.8)
pkg_check_modules(GIO REQUIRED gio-unix-2.0)
pkg_check_modules(RSVG REQUIRED librsvg-2.0)
pkg_check_modules(WNCK REQUIRED libwnck-3.0)
pkg_check_modules(FONTCONFIG REQUIRED fontconfig)
pkg_check_modules(GLIB REQUIRED glib-2.0)

OPTION(TEST_BUILD "Build with native testing" ON)

if (NOT DEFINED VERSION)
find_package(Git)
message("generate version from git")
execute_process(COMMAND ${GIT_EXECUTABLE}
    describe --abbrev=6 --dirty --tags
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)
endif()
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/constant.vala.in
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/constant.vala
)

if(TEST_BUILD)
message("set project_path to native test")
execute_process(
    COMMAND sed s|@@PROJECT_PATH@@|\"${CMAKE_SOURCE_DIR}\"|g
    OUTPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c
    INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c.in
)
list(APPEND ARGS_DEFINITIONS "TEST_BUILD")
else()
message("set project_path to ${CMAKE_INSTALL_PREFIX}")
execute_process(
    COMMAND sed s|@@PROJECT_PATH@@|\"${CMAKE_INSTALL_PREFIX}\"|g
    OUTPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c
    INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c.in
)
endif()

ExternalProject_Add(Vte-0.29
  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1
  CONFIGURE_COMMAND ./configure --enable-static
  BUILD_COMMAND make
  INSTALL_COMMAND ""
  BUILD_IN_SOURCE 1
  )

ExternalProject_Add(zssh-1.5c
  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c
  CONFIGURE_COMMAND ./configure
  BUILD_COMMAND make
  INSTALL_COMMAND ""
  BUILD_IN_SOURCE 1
  )

set(CFLAGS
	${GIO_CFLAGS}
	${GTK3_CFLAGS} ${GTK3_CFLAGS_OTHER}
	${GEE_CFLAGS}
	${X11_CFLAGS} ${X11_CFLAGS_OTHER}
	-DWNCK_I_KNOW_THIS_IS_UNSTABLE
	-DGETTEXT_PACKAGE=${target}
	-s -O3 -w
	#	-g
)
add_compile_options(${CFLAGS})
set(INCLUDE_PATHS
	${GIO_INCLUDE_DIRS}
	${GTK3_INCLUDE_DIRS}
	${GEE_INCLUDE_DIRS}
	${WNCK_INCLUDE_DIRS}
	${RSVG_INCLUDE_DIRS}
	${JsonGlib_INCLUDE_DIRS}
	${LIBSECRET_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1/src
)
find_library(VTE_LIB NAMES libvte-2.91.a tcmalloc_minimal)
include_directories(${INCLUDE_PATHS})
set(LIBS
	${GIO_LIBRARIES}
	${GTK3_LIBRARIES}
	${GEE_LIBRARIES}
	${WNCK_LIBRARIES}
	${RSVG_LIBRARIES}
	${JsonGlib_LIBRARIES}
	${LIBSECRET_LIBRARIES}
	${ZLIB_LIBRARIES}
	${X11_LIBRARIES}
	${XTST_LIBRARIES}
	${FONTCONFIG_LIBRARY}
	${M_LIBRARIES}
	stdc++
	m
	z
	pthread
	gnutls
	pcre2-8
)
SET(APP_SOURCES, "")
FILE(GLOB valalist LIST_FILES true */*.vala)
FOREACH(child ${valalist})
	file(RELATIVE_PATH
    file_path
    ${CMAKE_SOURCE_DIR}
    ${child}
	)
	set (APP_SOURCES ${APP_SOURCES} ${file_path})
ENDFOREACH()

vala_precompile(VALA_C
	./main.vala
	${APP_SOURCES}

OPTIONS
--vapidir=${CMAKE_SOURCE_DIR}/vapi

PACKAGES
	xcb
	gtk+-3.0
	vte-2.91
	gee-0.8
	json-glib-1.0
	gio-2.0
	libwnck-3.0
	posix
	fontconfig
	libsecret-1
	gdk-x11-3.0
	glib-2.0
	librsvg-2.0
)
add_executable(${target} ${VALA_C} ${CMAKE_SOURCE_DIR}/project_path.c ${CMAKE_SOURCE_DIR}/lib/font.c)
target_link_libraries(${target} ${LIBS} ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1/src/.libs/libvte-2.91.a)
add_dependencies(${target} Vte-0.29)

FILE(GLOB children LIST_DIRECTORIES true po/*)
SET(dirlist "")

FOREACH(child ${children})
	IF(IS_DIRECTORY ${child})
		get_filename_component(childdir ${child} NAME)
		LIST(APPEND dirlist ${childdir})
	ENDIF()
ENDFOREACH()

FOREACH(lang ${dirlist})
	SET(gmoFiles)
	FOREACH(current_PO_FILE po/${lang}/LC_MESSAGES/deepin-terminal.po)
    	  SET(gmoFile ${CMAKE_CURRENT_BINARY_DIR}/${lang}-${target}.gmo)
    	  SET(INSTALL_DESTINATION share/locale/)
    	  ADD_CUSTOM_COMMAND(OUTPUT ${gmoFile}
    	        COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${gmoFile} ${current_PO_FILE}
    	        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    	        DEPENDS ${current_PO_FILE}
    	     )
    	  INSTALL(FILES ${gmoFile} DESTINATION ${INSTALL_DESTINATION}/${lang}/LC_MESSAGES/  RENAME ${target}.mo)
	
    	  LIST(APPEND gmoFiles ${gmoFile})
    ENDFOREACH(current_PO_FILE)

    ADD_CUSTOM_TARGET(${lang} ALL DEPENDS ${gmoFiles})
	
ENDFOREACH(lang)

INSTALL (TARGETS ${target} DESTINATION bin)
INSTALL (PROGRAMS ssh_login.sh ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c/zssh DESTINATION lib/${target})
INSTALL (FILES hicolor/32x32/${target}.png DESTINATION share/icons/hicolor/32x32/apps)
INSTALL (FILES hicolor/48x48/${target}.png DESTINATION share/icons/hicolor/48x48/apps)
INSTALL (FILES hicolor/96x96/${target}.png DESTINATION share/icons/hicolor/96x96/apps)
INSTALL (FILES hicolor/128x128/${target}.png DESTINATION share/icons/hicolor/128x128/apps)
INSTALL (FILES hicolor/${target}.svg DESTINATION share/icons/hicolor/scalable/apps)
INSTALL (DIRECTORY image DESTINATION share/${target} FILES_MATCHING PATTERN "*.png")
INSTALL (DIRECTORY image DESTINATION share/${target} FILES_MATCHING PATTERN "*.svg")
INSTALL (DIRECTORY theme DESTINATION share/${target} FILES_MATCHING PATTERN "*")
INSTALL (FILES style.css DESTINATION share/${target})
INSTALL (FILES ${target}.desktop DESTINATION share/applications)

=== debian/changelog ===
deepin-terminal (3.0.3+ds-1) unstable; urgency=medium

  * New upstream version 3.0.3+ds
  * Bump Standards-Version to 4.2.0 (no changes needed).

 -- Yanhao Mo <yanhaocs@gmail.com>  Mon, 20 Aug 2018 15:23:39 +0800

deepin-terminal (3.0.1+ds-1) unstable; urgency=medium

  * New upstream version 3.0.1+ds
  * Bump Standards-Version to 4.1.5 (no changes needed).

 -- Yanhao Mo <yanhaocs@gmail.com>  Sat, 21 Jul 2018 11:16:43 +0800

deepin-terminal (3.0.0+ds-2) unstable; urgency=medium

  * Add missing runtime dependency zssh (Closes: #900644).

 -- Yanhao Mo <yanhaocs@gmail.com>  Thu, 14 Jun 2018 08:44:42 +0800

deepin-terminal (3.0.0+ds-1) unstable; urgency=medium

  [ Yanhao Mo ]
  * New upstream release.
  * d/control: Add new uploader Yanhao Mo <yanhaocs@gmail.com>.
  * d/patches: modify patches to adapt to new upstream version.
  * d/rules: Refresh to build new package.
  * d/copyright: Exclude 3rdparty/ directory.
  * d/source/lintian-overrides: No need to override anything, delete it.
  * Bump Standards-Version to 4.1.4 (No changes needed).

  [ Boyuan Yang ]
  * d/rules: Use "dh_missing --fail-missing".

 -- Boyuan Yang <073plan@gmail.com>  Thu, 17 May 2018 21:05:16 +0800

=== debian/control ===
Source: deepin-terminal
Section: x11
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <073plan@gmail.com>,
Build-Depends:
 cmake,
 debhelper (>= 11~),
 gettext,
 gnome-pkg-tools (>= 0.10),
 gobject-introspection (>= 0.9.12-4~),
 gperf,
 gtk-doc-tools,
 intltool (>= 0.35),
 libgee-0.8-dev,
 libgirepository1.0-dev (>= 0.9.12),
 libgladeui-dev,
 libglib2.0-dev (>= 2.40.0),
 libgnutls28-dev (>= 3.2.7),
 libgtk-3-dev (>= 3.20),
 libjson-glib-dev,
 libpango1.0-dev (>= 1.22.0),
 libpcre2-dev (>= 10.21),
 libreadline-dev,
 librsvg2-dev,
 libsecret-1-dev,
 libvte-2.91-dev,
 libwnck-3-dev,
 libxml2-utils,
 valac,
Standards-Version: 4.2.0
Homepage: https://github.com/linuxdeepin/deepin-terminal
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

Package: deepin-terminal
Architecture: any
Provides:
 x-terminal-emulator,
Depends:
 dbus-x11,
 deepin-menu,
 expect,
 lrzsz,
 zssh,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin terminal emulator application
 Deepin Terminal is an advanced terminal emulator with workspace, multiple
 windows, remote management, quake mode and other features. It sharpens your
 focus in the world of command line.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/watch ===
version=4
opts="dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repacksuffix=+ds, \
   filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-terminal-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-terminal/tags \
   (?:.*?/)?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-terminal 3.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 pkg_check_modules(WNCK REQUIRED libwnck-3.0)
 pkg_check_modules(FONTCONFIG REQUIRED fontconfig)
 pkg_check_modules(GLIB REQUIRED glib-2.0)
+pkg_check_modules(VTE REQUIRED vte-2.91)
 
 OPTION(TEST_BUILD "Build with native testing" ON)
 
@@ -59,22 +60,6 @@
 )
 endif()
 
-ExternalProject_Add(Vte-0.29
-  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1
-  CONFIGURE_COMMAND ./configure --enable-static
-  BUILD_COMMAND make
-  INSTALL_COMMAND ""
-  BUILD_IN_SOURCE 1
-  )
-
-ExternalProject_Add(zssh-1.5c
-  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c
-  CONFIGURE_COMMAND ./configure
-  BUILD_COMMAND make
-  INSTALL_COMMAND ""
-  BUILD_IN_SOURCE 1
-  )
-
 set(CFLAGS
 	${GIO_CFLAGS}
 	${GTK3_CFLAGS} ${GTK3_CFLAGS_OTHER}
@@ -94,9 +79,8 @@
 	${RSVG_INCLUDE_DIRS}
 	${JsonGlib_INCLUDE_DIRS}
 	${LIBSECRET_INCLUDE_DIRS}
-	${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1/src
+	${VTE_INCLUDE_DIRS}
 )
-find_library(VTE_LIB NAMES libvte-2.91.a tcmalloc_minimal)
 include_directories(${INCLUDE_PATHS})
 set(LIBS
 	${GIO_LIBRARIES}
@@ -111,6 +95,7 @@
 	${XTST_LIBRARIES}
 	${FONTCONFIG_LIBRARY}
 	${M_LIBRARIES}
+	${VTE_LIBRARIES}
 	stdc++
 	m
 	z
@@ -133,9 +118,6 @@
 	./main.vala
 	${APP_SOURCES}
 
-OPTIONS
---vapidir=${CMAKE_SOURCE_DIR}/vapi
-
 PACKAGES
 	xcb
 	gtk+-3.0
@@ -145,15 +127,13 @@
 	gio-2.0
 	libwnck-3.0
 	posix
-	fontconfig
 	libsecret-1
 	gdk-x11-3.0
 	glib-2.0
 	librsvg-2.0
 )
 add_executable(${target} ${VALA_C} ${CMAKE_SOURCE_DIR}/project_path.c ${CMAKE_SOURCE_DIR}/lib/font.c)
-target_link_libraries(${target} ${LIBS} ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.50.1/src/.libs/libvte-2.91.a)
-add_dependencies(${target} Vte-0.29)
+target_link_libraries(${target} ${LIBS})
 
 FILE(GLOB children LIST_DIRECTORIES true po/*)
 SET(dirlist "")
@@ -185,7 +165,7 @@
 ENDFOREACH(lang)
 
 INSTALL (TARGETS ${target} DESTINATION bin)
-INSTALL (PROGRAMS ssh_login.sh ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c/zssh DESTINATION lib/${target})
+INSTALL (PROGRAMS ssh_login.sh DESTINATION lib/${target})
 INSTALL (FILES hicolor/32x32/${target}.png DESTINATION share/icons/hicolor/32x32/apps)
 INSTALL (FILES hicolor/48x48/${target}.png DESTINATION share/icons/hicolor/48x48/apps)
 INSTALL (FILES hicolor/96x96/${target}.png DESTINATION share/icons/hicolor/96x96/apps)

=== debian/changelog ===
deepin-terminal (3.0.7-1) unstable; urgency=medium

  * New upstream version 3.0.7
  * Bump Standards-Version to 4.2.1 (no changes needed).
  * drop d/patch/0002-use-system-lib, applyed by upstream.
  * d/copyright: remove license info of vapi/xcb.vapi.
  * d/watch: simplify it by using "dversionmangle=auto".

 -- Yanhao Mo <yanhaocs@gmail.com>  Sun, 14 Oct 2018 18:38:29 +0800

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
  libwnck-3-dev,
  libxml2-utils,
  valac,
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://github.com/linuxdeepin/deepin-terminal
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	        -DTEST_BUILD=OFF

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="dversionmangle=auto, repacksuffix=+ds, \
   filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-terminal-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-terminal/tags \
   (?:.*?/)?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-terminal 3.0.8

=== debian/changelog ===
deepin-terminal (3.0.8-1) unstable; urgency=medium

  * Update d/watch
  * Remove d/patches, applyed by upstream.
  * New upstream version 3.0.8

 -- Yanhao Mo <yanhaocs@gmail.com>  Wed, 24 Oct 2018 09:50:12 +0800

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-terminal-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-terminal/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-terminal 3.2+ds1

=== debian/changelog ===
deepin-terminal (3.2+ds1-1) unstable; urgency=medium

  * New upstream version 3.2.
  * Revert upstream commit about adding Debian Stretch support back
    (vendoring libraries).
  * debian/control:
    + Update my uploader email address and use @debian.org one.
    + Build-depend on debhelper-compat (= 12) instead of using
      debian/compat file.
    + Bump Standards-Version to 4.3.0.
  * debian/rules:
    + Add back vala workarounds.
  * debian/watch: Add version mangling.

 -- Boyuan Yang <byang@debian.org>  Fri, 11 Jan 2019 10:22:48 -0500

## deepin-terminal 3.2.1.1+ds1

=== debian/changelog ===
deepin-terminal (3.2.1.1+ds1-1) unstable; urgency=medium

  * New upstream version 3.2.1.1+ds1
  * d/patches: Add a patch to get rid of lintian warning:
    desktop-entry-invalid-category.

 -- Yanhao Mo <yanhaocs@gmail.com>  Tue, 26 Feb 2019 14:00:19 +0800

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
- Boyuan Yang <073plan@gmail.com>,
+ Boyuan Yang <byang@debian.org>,
 Build-Depends:
  cmake,
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  gettext,
  gnome-pkg-tools (>= 0.10),
  gobject-introspection (>= 0.9.12-4~),
@@ -31,7 +31,8 @@
  libwnck-3-dev,
  libxml2-utils,
  valac,
-Standards-Version: 4.2.1
+Rules-Requires-Root: no
+Standards-Version: 4.3.0
 Homepage: https://github.com/linuxdeepin/deepin-terminal
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

## deepin-terminal 5.0.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,9 +24,13 @@
 pkg_check_modules(WNCK REQUIRED libwnck-3.0)
 pkg_check_modules(FONTCONFIG REQUIRED fontconfig)
 pkg_check_modules(GLIB REQUIRED glib-2.0)
+
+option(TEST_BUILD "Build with native testing" ON)
+option(USE_VENDOR_LIB "Backport support for debian stretch" ON)
+
+if (NOT USE_VENDOR_LIB)
 pkg_check_modules(VTE REQUIRED vte-2.91)
-
-OPTION(TEST_BUILD "Build with native testing" ON)
+endif()
 
 if (NOT DEFINED VERSION)
 find_package(Git)
@@ -58,6 +62,24 @@
     OUTPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c
     INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/project_path.c.in
 )
+endif()
+
+if (USE_VENDOR_LIB)
+ExternalProject_Add(Vte-0.52
+  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.52.1
+  CONFIGURE_COMMAND ./configure --enable-static
+  BUILD_COMMAND make
+  INSTALL_COMMAND ""
+  BUILD_IN_SOURCE 1
+  )
+
+ExternalProject_Add(zssh-1.5c
+  SOURCE_DIR ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c
+  CONFIGURE_COMMAND ./configure
+  BUILD_COMMAND make
+  INSTALL_COMMAND ""
+  BUILD_IN_SOURCE 1
+  )
 endif()
 
 set(CFLAGS
@@ -79,8 +101,15 @@
 	${RSVG_INCLUDE_DIRS}
 	${JsonGlib_INCLUDE_DIRS}
 	${LIBSECRET_INCLUDE_DIRS}
-	${VTE_INCLUDE_DIRS}
-)
+)
+
+if (USE_VENDOR_LIB)
+	list(APPEND INCLUDE_PATHS ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.52.1/src)
+	find_library(VTE_LIB NAMES libvte-2.91.a tcmalloc_minimal)
+else()
+	list(APPEND INCLUDE_PATHS ${VTE_INCLUDE_DIRS})
+endif()
+
 include_directories(${INCLUDE_PATHS})
 set(LIBS
 	${GIO_LIBRARIES}
@@ -95,7 +124,6 @@
 	${XTST_LIBRARIES}
 	${FONTCONFIG_LIBRARY}
 	${M_LIBRARIES}
-	${VTE_LIBRARIES}
 	stdc++
 	m
 	z
@@ -103,6 +131,11 @@
 	gnutls
 	pcre2-8
 )
+
+if (NOT USE_VENDOR_LIB)
+	list(APPEND LIBS ${VTE_LIBRARIES})
+endif()
+
 SET(APP_SOURCES, "")
 FILE(GLOB valalist LIST_FILES true */*.vala)
 FOREACH(child ${valalist})
@@ -114,11 +147,7 @@
 	set (APP_SOURCES ${APP_SOURCES} ${file_path})
 ENDFOREACH()
 
-vala_precompile(VALA_C
-	./main.vala
-	${APP_SOURCES}
-
-PACKAGES
+set(VALA_PRECOMPILE_PACKAGES
 	xcb
 	gtk+-3.0
 	vte-2.91
@@ -132,8 +161,38 @@
 	glib-2.0
 	librsvg-2.0
 )
+
+if (USE_VENDOR_LIB)
+	list(APPEND VALA_PRECOMPILE_PACKAGES fontconfig)
+
+	vala_precompile(VALA_C
+		./main.vala
+		${APP_SOURCES}
+
+	OPTIONS
+	--vapidir=${CMAKE_SOURCE_DIR}/vapi
+
+	PACKAGES
+		${VALA_PRECOMPILE_PACKAGES}
+	)
+else()
+	vala_precompile(VALA_C
+		./main.vala
+		${APP_SOURCES}
+
+	PACKAGES
+		${VALA_PRECOMPILE_PACKAGES}
+	)
+endif()
+
 add_executable(${target} ${VALA_C} ${CMAKE_SOURCE_DIR}/project_path.c ${CMAKE_SOURCE_DIR}/lib/font.c)
-target_link_libraries(${target} ${LIBS})
+
+if (USE_VENDOR_LIB)
+	target_link_libraries(${target} ${LIBS} ${CMAKE_SOURCE_DIR}/3rdparty/vte-0.52.1/src/.libs/libvte-2.91.a)
+	add_dependencies(${target} Vte-0.52)
+else()
+	target_link_libraries(${target} ${LIBS})
+endif()
 
 FILE(GLOB children LIST_DIRECTORIES true po/*)
 SET(dirlist "")
@@ -156,16 +215,20 @@
     	        DEPENDS ${current_PO_FILE}
     	     )
     	  INSTALL(FILES ${gmoFile} DESTINATION ${INSTALL_DESTINATION}/${lang}/LC_MESSAGES/  RENAME ${target}.mo)
-	
+
     	  LIST(APPEND gmoFiles ${gmoFile})
     ENDFOREACH(current_PO_FILE)
 
     ADD_CUSTOM_TARGET(${lang} ALL DEPENDS ${gmoFiles})
-	
+
 ENDFOREACH(lang)
 
 INSTALL (TARGETS ${target} DESTINATION bin)
-INSTALL (PROGRAMS ssh_login.sh DESTINATION lib/${target})
+if (USE_VENDOR_LIB)
+	INSTALL (PROGRAMS ${CMAKE_SOURCE_DIR}/3rdparty/ssh_login.sh ${CMAKE_SOURCE_DIR}/3rdparty/zssh-1.5c/zssh DESTINATION lib/${target})
+else()
+	INSTALL (PROGRAMS ssh_login.sh DESTINATION lib/${target})
+endif()
 INSTALL (FILES hicolor/32x32/${target}.png DESTINATION share/icons/hicolor/32x32/apps)
 INSTALL (FILES hicolor/48x48/${target}.png DESTINATION share/icons/hicolor/48x48/apps)
 INSTALL (FILES hicolor/96x96/${target}.png DESTINATION share/icons/hicolor/96x96/apps)

=== debian/changelog ===
deepin-terminal (5.0.0+ds1-3) unstable; urgency=medium

  * debian/patches:
    + Add 0004-basic-wayland-support patch file. (Closes: #987933, #894323)
  * debian/control:
    + Add Arun Kumar Pariyar to uploaders list.

 -- Arun Kumar Pariyar <openarungeek@gmail.com>  Mon, 03 May 2021 00:46:19 +0545

deepin-terminal (5.0.0+ds1-2) unstable; urgency=high

  * debian/patches: Add upstream PR to fix FTBFS with new libvte
    (Closes: #954581)
  * debian/control: Bump Standards-Version to 4.5.0.

 -- Boyuan Yang <byang@debian.org>  Thu, 23 Apr 2020 19:18:02 -0400

deepin-terminal (5.0.0+ds1-1) unstable; urgency=medium

  * New upstream release 5.0.0+ds1. 
  * debian/control: Bump Standards-Version to 4.4.1.

 -- Boyuan Yang <byang@debian.org>  Fri, 15 Nov 2019 10:47:51 -0500

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Yangfl <mmyangfl@gmail.com>,
  Yanhao Mo <yanhaocs@gmail.com>,
  Boyuan Yang <byang@debian.org>,
+ Arun Kumar Pariyar <openarungeek@gmail.com>,
 Build-Depends:
  cmake,
  debhelper-compat (= 12),
@@ -32,7 +33,7 @@
  libxml2-utils,
  valac,
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/linuxdeepin/deepin-terminal
 Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
 Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%deepin-terminal-$1.tar.gz%" \
   https://github.com/linuxdeepin/deepin-terminal/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## deepin-terminal 5.2.11

=== CMakeLists.txt ===
project(deepin-terminal)

cmake_minimum_required(VERSION 3.9.5)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

include (src/DtkSettingsToolsMacros)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_MINIMUM_VERSION "5.7.1")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

configure_file(src/environments.h.in environments.h @ONLY)

# Find the QtWidgets library

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Network REQUIRED)
#find_package(DtkWidget REQUIRED)
#find_package(DtkCore REQUIRED)
#find_package(DtkGui REQUIRED)

include(FindPkgConfig)

pkg_search_module(DtkWidget REQUIRED dtkwidget)
pkg_search_module(DtkGui REQUIRED dtkgui)
pkg_search_module(DtkCore REQUIRED dtkcore)
pkg_search_module(GOBJECT REQUIRED gobject-2.0)
pkg_check_modules(ATSPI2 REQUIRED atspi-2)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

# Compile definitions for TerminalWidget
# So we can use QT_VERSION_CHECK
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

add_subdirectory(3rdparty/terminalwidget)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

include_directories("src/common")
include_directories("src/customcommand")
include_directories("src/encodeplugin")
include_directories("src/main")
include_directories("src/quaketerminal")
include_directories("src/remotemanage")
include_directories("src/settings")
include_directories("src/theme")
include_directories("src/views")
include_directories("3rdparty/terminalwidget/lib")

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::WidgetsPrivate
    Qt5::Network

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${ATSPI2_LIBRARIES}
    ${GOBJECT_LIBRARIES}
)

# Populate a CMake variable with the sources
# TODO: portable headers?
set (DTNG_CPP_FILES
    src/common/utils.cpp
    src/customcommand/customcommanddelegate.cpp
    src/customcommand/customcommanditemmodel.cpp
    src/customcommand/customcommandlist.cpp
    src/customcommand/customcommandoptdlg.cpp
    src/customcommand/customcommandpanel.cpp
    src/customcommand/customcommandplugin.cpp
    src/customcommand/customcommandsearchrstpanel.cpp
    src/customcommand/customcommandtoppanel.cpp
    src/encodeplugin/encodepanelplugin.cpp
    src/encodeplugin/encodepanel.cpp
    src/encodeplugin/encodelistview.cpp
    src/encodeplugin/encodelistmodel.cpp
    src/main/main.cpp
    src/main/service.cpp
    src/main/windowsmanager.cpp
    src/main/mainwindow.cpp
    src/main/terminalapplication.cpp
    src/main/termproperties.cpp    
    src/main/dbusmanager.cpp
    src/main/atspidesktop.cpp
    src/quaketerminal/quaketerminaladapter.cpp
    src/quaketerminal/quaketerminalproxy.cpp
    src/quaketerminal/termargumentparser.cpp
    src/remotemanage/remotemanagementpanel.cpp
    src/remotemanage/remotemanagementplugn.cpp
    src/remotemanage/remotemanagementsearchpanel.cpp
    src/remotemanage/remotemanagementtoppanel.cpp
    src/remotemanage/serverconfigdelegate.cpp
    src/remotemanage/serverconfiggrouppanel.cpp
    src/remotemanage/serverconfigitemmodel.cpp
    src/remotemanage/serverconfiglist.cpp
    src/remotemanage/serverconfigmanager.cpp
    src/remotemanage/serverconfigoptdlg.cpp
    src/settings/newdspinbox.cpp
    src/settings/settings.cpp
    src/settings/settings_translation.cpp
    src/settings/shortcutmanager.cpp
    src/theme/themeitemdelegate.cpp
    src/theme/themelistmodel.cpp
    src/theme/themelistview.cpp
    src/theme/themepanel.cpp
    src/theme/themepanelplugin.cpp
    src/views/commonpanel.cpp
    src/views/myiconbutton.cpp
    src/views/warnningdlg.cpp
    src/views/operationconfirmdlg.cpp
    src/views/pagesearchbar.cpp
    src/views/rightpanel.cpp
    src/views/tabbar.cpp
    src/views/termwidget.cpp
    src/views/termwidgetpage.cpp
    src/views/termbasedialog.cpp
    src/views/terminputdialog.cpp
    src/views/termcommandlinkbutton.cpp
    src/views/titlebar.cpp
)

set (DTNG_HEADER_FILES
    src/common/define.h
    src/common/utils.h
    src/customcommand/customcommanddelegate.h
    src/customcommand/customcommanditemmodel.h
    src/customcommand/customcommandlist.h
    src/customcommand/customcommandoptdlg.h
    src/customcommand/customcommandpanel.h
    src/customcommand/customcommandplugin.h
    src/customcommand/customcommandsearchrstpanel.h
    src/customcommand/customcommandtoppanel.h
    src/encodeplugin/encodepanelplugin.h
    src/encodeplugin/encodepanel.h
    src/encodeplugin/encodelistview.h
    src/encodeplugin/encodelistmodel.h
    src/main/windowsmanager.h
    src/main/mainwindow.h
    src/main/mainwindowplugininterface.h
    src/main/service.h
    src/main/terminalapplication.h
    src/main/termproperties.h
    src/main/dbusmanager.h
    src/main/atspidesktop.h
    src/quaketerminal/quaketerminaladapter.h
    src/quaketerminal/quaketerminalproxy.h
    src/quaketerminal/termargumentparser.h
    src/remotemanage/remotemanagementpanel.h
    src/remotemanage/remotemanagementplugn.h
    src/remotemanage/remotemanagementsearchpanel.h
    src/remotemanage/remotemanagementtoppanel.h
    src/remotemanage/serverconfigdelegate.h
    src/remotemanage/serverconfiggrouppanel.h
    src/remotemanage/serverconfigitemmodel.h
    src/remotemanage/serverconfiglist.h
    src/remotemanage/serverconfigmanager.h
    src/remotemanage/serverconfigoptdlg.h
    src/settings/newdspinbox.h
    src/settings/settings.h
    src/settings/shortcutmanager.h
    src/theme/themeitemdelegate.h
    src/theme/themelistmodel.h
    src/theme/themelistview.h
    src/theme/themepanel.h
    src/theme/themepanelplugin.h
    src/views/commonpanel.h
    src/views/myiconbutton.h
    src/views/operationconfirmdlg.h
    src/views/warnningdlg.h
    src/views/pagesearchbar.h
    src/views/rightpanel.h
    src/views/tabbar.h
    src/views/termwidget.h
    src/views/termwidgetpage.h
    src/views/titlebar.h
    src/views/termbasedialog.h
    src/views/terminputdialog.h
    src/views/termcommandlinkbutton.h
)

set (DTNG_QRC_FILES
    src/assets/resources.qrc
)

# Program
set (EXE_NAME deepin-terminal)

# Translation
file (GLOB DTNG_TS_FILES translations/*.ts)
set (DTNG_CPP_FILES_FOR_I18N ${DTNG_CPP_FILES})

dtk_create_i18n_from_json(DTNG_SETTINGS_I18N_FILES default-config.json settings_translation.cpp)
list (APPEND DTNG_CPP_FILES_FOR_I18N ${DTNG_SETTINGS_I18N_FILES})
qt5_create_translation(DTNG_QM_FILES ${DTNG_CPP_FILES_FOR_I18N} ${DTNG_TS_FILES})

add_executable (${EXE_NAME}
    ${DTNG_HEADER_FILES}
    ${DTNG_CPP_FILES}
    ${DTNG_QRC_FILES}
    ${DTNG_QM_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Core_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS}
                                              ${ATSPI2_INCLUDE_DIRS}
                                              ${GOBJECT_INCLUDE_DIRS})

target_link_libraries (deepin-terminal ${LINK_LIBS} terminalwidget5)

# Install settings

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# Installation

#install(TARGETS deepin-terminal DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-terminal)

install(FILES src/deepin-terminal.desktop
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)

install(FILES src/assets/logo/deepin-terminal.svg
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

# add this empty file for first install/reinstall judge
install(FILES src/assets/other/install_flag
        DESTINATION $ENV{HOME}/.config/deepin/deepin-terminal/)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-terminal
        DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
        PERMISSIONS OWNER_READ OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

install(FILES ${DTNG_QM_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-terminal/translations)

=== 3rdparty/terminalwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(terminalwidget)

include(GNUInstallDirs)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
include(CheckIncludeFile)

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
option(TERMINALWIDGET_USE_UTEMPTER "Uses the libutempter library. Mainly for FreeBSD" OFF)
option(TERMINALWIDGET_BUILD_PYTHON_BINDING "Build python binding" OFF)
option(USE_UTF8PROC "Use libutf8proc for better Unicode support. Default OFF" OFF)


# just change version for releases
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

set(TERMINALWIDGET_VERSION "${TERMINALWIDGET_VERSION_MAJOR}.${TERMINALWIDGET_VERSION_MINOR}.${TERMINALWIDGET_VERSION_PATCH}")

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_INSTALL_PREFIX "/usr")

# Minimum Versions
set(QT_MINIMUM_VERSION "5.7.1")
set(LXQTBT_MINIMUM_VERSION "0.6.0")

find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)

if(USE_UTF8PROC)
    find_package(Utf8Proc REQUIRED)
endif()

include(LXQtPreventInSourceBuilds)
include(LXQtTranslateTs)
include(LXQtCompilerSettings NO_POLICY_SCOPE)
include(LXQtCreatePkgConfigFile)

if(APPLE)
    if(CMAKE_VERSION VERSION_GREATER 3.9)
        cmake_policy(SET CMP0068 NEW)
        set(CMAKE_BUILD_WITH_INSTALL_NAME_DIR ON)
    endif()
endif()

set(TERMINALWIDGET_LIBRARY_NAME terminalwidget5)


# main library

set(SRCS
    lib/BlockArray.cpp
    lib/ColorScheme.cpp
    lib/Emulation.cpp
    lib/Filter.cpp
    lib/History.cpp
    lib/HistorySearch.cpp
    lib/KeyboardTranslator.cpp
    lib/konsole_wcwidth.cpp
    lib/kprocess.cpp
    lib/kpty.cpp
    lib/kptydevice.cpp
    lib/kptyprocess.cpp
    lib/ProcessInfo.cpp
    lib/Pty.cpp
    lib/qtermwidget.cpp
    lib/Screen.cpp
    lib/ScreenWindow.cpp
    lib/SearchBar.cpp
    lib/Session.cpp
    lib/SessionManager.cpp
    lib/ShellCommand.cpp
    lib/TerminalCharacterDecoder.cpp
    lib/TerminalDisplay.cpp
    lib/tools.cpp
    lib/Vt102Emulation.cpp
)

# Only the Headers that need to be moc'd go here
set(HDRS
    lib/Emulation.h
    lib/Filter.h
    lib/HistorySearch.h
    lib/kprocess.h
    lib/kptydevice.h
    lib/kptyprocess.h
    lib/ProcessInfo.h
    lib/Pty.h
    lib/qtermwidget.h
    lib/ScreenWindow.h
    lib/SearchBar.h
    lib/Session.h
    lib/SessionManager.h
    lib/TerminalDisplay.h
    lib/Vt102Emulation.h
)

set(UI
    lib/SearchBar.ui
)

# for distribution
set(HDRS_DISTRIB
    lib/qtermwidget.h
    lib/Emulation.h
    lib/Filter.h
    lib/Session.h
    lib/SessionManager.h
    lib/History.h
    lib/BlockArray.h
    lib/Character.h
    lib/CharacterColor.h
    lib/TerminalDisplay.h
)

# dirs
set(KB_LAYOUT_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/kb-layouts")
message(STATUS "Keyboard layouts will be installed in: ${KB_LAYOUT_DIR}")

set(COLORSCHEMES_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/color-schemes")
message(STATUS "Color schemes will be installed in: ${COLORSCHEMES_DIR}" )

set(TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/translations")
message(STATUS "Translations will be installed in: ${TRANSLATIONS_DIR}")

set(TERMINALWIDGET_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}")

CHECK_FUNCTION_EXISTS(updwtmpx HAVE_UPDWTMPX)

qt5_wrap_cpp(MOCS ${HDRS})
qt5_wrap_ui(UI_SRCS ${UI})
set(PKG_CONFIG_REQ "Qt5Widgets")

lxqt_translate_ts(TERMINALWIDGET_QM
    TRANSLATION_DIR "lib/translations"
    UPDATE_TRANSLATIONS
        ${UPDATE_TRANSLATIONS}
    SOURCES
        ${SRCS} ${HDRS} ${UI}
    INSTALL_DIR
        ${TRANSLATIONS_DIR}
    COMPONENT
        Runtime
)

add_library(${TERMINALWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${TERMINALWIDGET_QM})
target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} Qt5::Widgets)
set_target_properties( ${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES
                       SOVERSION ${TERMINALWIDGET_VERSION_MAJOR}
                       VERSION ${TERMINALWIDGET_VERSION}
                     )


if(APPLE)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTMPX"
            "UTMPX_COMPAT"
    )
endif()

if(HAVE_UPDWTMPX)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UPDWTMPX"
    )
endif()

if (TERMINALWIDGET_USE_UTEMPTER)
    CHECK_INCLUDE_FILE(utempter.h HAVE_UTEMPTER)
    if (HAVE_UTEMPTER)
        target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME} PRIVATE
                "HAVE_UTEMPTER"
        )
        target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} ulog)
    endif()
endif()

if (UTF8PROC_FOUND)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTF8PROC"
    )
    target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
        INTERFACE
            ${UTF8PROC_INCLUDE_DIRS}
    )
    target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME}
        ${UTF8PROC_LIBRARIES}
    )
    string(APPEND PKG_CONFIG_REQ ", libutf8proc")
endif()

if(APPLE)
    set (CMAKE_SKIP_RPATH 1)
    # this is a must to load the lib correctly
    set_target_properties(${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
    PRIVATE
        "KB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\""
        "COLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\""
        "TRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\""
        "HAVE_POSIX_OPENPT"
        "HAVE_SYS_TIME_H"
)


generate_export_header(${TERMINALWIDGET_LIBRARY_NAME}
    EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    EXPORT_MACRO_NAME TERMINALWIDGET_EXPORT
)

target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>"
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/lib>"
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}>"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    VERSION ${TERMINALWIDGET_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(EXPORT
    "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(FILES
    ${HDRS_DISTRIB} "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)
# keyboard layouts
install(DIRECTORY
    lib/kb-layouts/
    DESTINATION "${KB_LAYOUT_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.keytab"
)
# color schemes
install(DIRECTORY
    lib/color-schemes/
    DESTINATION "${COLORSCHEMES_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.*schem*"
)

lxqt_create_pkgconfig_file(
    PACKAGE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTION "TerminalWidget library for Qt ${TERMINALWIDGET_VERSION_MAJOR}.x"
    INCLUDEDIRS ${TERMINALWIDGET_LIBRARY_NAME}
    LIBS ${TERMINALWIDGET_LIBRARY_NAME}
    REQUIRES ${PKG_CONFIG_REQ}
    VERSION ${TERMINALWIDGET_VERSION}
    INSTALL
    COMPONENT Devel
)

configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config.cmake"
    @ONLY
)

install(FILES
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER
    COMPONENT Runtime
)

export(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    FILE "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-targets.cmake"
    EXPORT_LINK_INTERFACE_LIBRARIES
)
# end of main library


# example application
if(BUILD_EXAMPLE)
    set(EXAMPLE_SRC example/main.cpp)
    add_executable(example ${EXAMPLE_SRC})
    target_link_libraries(example ${TERMINALWIDGET_LIBRARY_NAME})
endif()
# end of example application

# python binding
if (TERMINALWIDGET_BUILD_PYTHON_BINDING)
    add_subdirectory(pyqt)
endif()
# end of python binding


CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)
ADD_CUSTOM_TARGET(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)

=== 3rdparty/terminalwidget/pyqt/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Match what's used in the main macros
cmake_policy(SET CMP0002 OLD)
find_package(PythonLibrary)

include(PythonMacros)

find_package(SIP)
include(SIPMacros)

if(SIP_VERSION STRLESS "040f03")    # These version numbers also appear in ../CMakeLists.txt
    message(FATAL_ERROR "The version of SIP found is too old. 4.15.3 or later is needed.")
endif()

find_package(PyQt5)
if(PYQT5_VERSION STRLESS "050101")  # These version numbers also appear in ../CMakeLists.txt
    message(FATAL_ERROR "The version of PyQt found is too old. 5.1.1 or later is required.")
endif()

set(SIP_INCLUDES ${PYQT5_SIP_DIR} sip)
set(SIP_CONCAT_PARTS 8)
set(SIP_TAGS ALL WS_X11 ${PYQT5_VERSION_TAG})
set(SIP_DISABLE_FEATURES VendorID PyQt_NoPrintRangeBug)

# Use an extra option when compiling on Python 3.
if (PYTHON_VERSION_MAJOR GREATER 2)
    if(PYQT5_VERSION STRGREATER "040904")
	    # Disable for newer PyQt
	    set(SIP_EXTRA_OPTIONS -P -g)
    else ()
	    set(SIP_EXTRA_OPTIONS -g)
    endif()
else (PYTHON_VERSION_MAJOR GREATER 2)
    if(PYQT5_VERSION STRGREATER "040904")
	# Disable for newer PyQt
        set(SIP_EXTRA_OPTIONS -P -g  -x Py_v3)
    else ()
	    set(SIP_EXTRA_OPTIONS -g -x Py_v3)
    endif()
endif ()

include_directories(
    "${SIP_INCLUDE_DIR}"
)

add_definitions(-D_REENTRANT -DSIP_PROTECTED_IS_PUBLIC -Dprotected=public)

file(GLOB qtermwidget_files_sip sip/*.sip)
set(SIP_EXTRA_FILES_DEPEND "${qtermwidget_files_sip}")
add_sip_python_module(QTermWidget sip/qtermwidget.sip qtermwidget5)

python_install(__init__.py "${PYTHON_SITE_PACKAGES_INSTALL_DIR}/PyQt5/qtermwidget")

set (SIP_FILES_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/sip")

install(DIRECTORY sip/ DESTINATION "${SIP_FILES_INSTALL_DIR}/PyQt5/qtermwidget"
    PATTERN "*~" EXCLUDE    # This sucks, why can't I just whitelist what I _do_ want?
    PATTERN ".svn" EXCLUDE
    PATTERN "*.in" EXCLUDE
)

=== debian/changelog ===
deepin-terminal (5.2.11-1build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 19 Mar 2022 21:57:18 +0300

deepin-terminal (5.2.11-1) unstable; urgency=medium

  * Upload to unstable. 

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Nov 2021 23:39:36 -0500

deepin-terminal (5.2.11-1~exp1) experimental; urgency=medium

  [ Arun Kumar Pariyar ]
  * New upstream version 5.2.11.
  * debian/control:
    + Bump debhelper compat to v13.
    + Cleanup un-used the build-depends.
    + Remove deepin-menu from package dependency.
  * debian/patches:
    + Remove 0002-vala-libify-raw_data-conversion-for-Terminal-feed_ch.patch
    + Remove 0003-utils-adjust-to-change-in-vte3-0.59.0.patch
    + Add 0002-fix-desktop-entry-invalid-category-for-DDE.patch
    + Add 0003-remove-definitions-DQT_NO_CAST_FROM_ASCII-DQT_NO_CAS.patch
  * debian/postrm
    + Add sript to remove user configuration for deepin-terminal.
  * debian/rules:
    + Remove valaflags.

  [ Boyuan Yang ]
  * debian/control:
    + Tighten build dependency versions.
    + Bump Standards-Version to 4.6.0.
    + Drop Yangfl from uploaders list as requested.

 -- Boyuan Yang <byang@debian.org>  Tue, 09 Nov 2021 13:39:44 -0500

=== debian/control ===
Source: deepin-terminal
Section: x11
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <openarungeek@gmail.com>,
Build-Depends:
 chrpath,
 cmake,
 debhelper-compat (= 13),
 libatspi2.0-dev,
 libdframeworkdbus-dev (>= 5.4.20~),
 libdtkwidget-dev (>= 5.5.17~),
 libglib2.0-dev,
 libutf8proc-dev,
 lxqt-build-tools (>= 0.6.0~),
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/linuxdeepin/deepin-terminal
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

Package: deepin-terminal
Architecture: any
Provides:
 x-terminal-emulator,
Depends:
 expect,
 zssh,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin terminal emulator application
 Deepin Terminal is an advanced terminal emulator with workspace, multiple
 windows, remote management, quake mode and other features. It sharpens your
 focus in the world of command line.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/default.mk

%:
	dh $@

execute_after_dh_auto_install:
	rm -rf debian/deepin-terminal/build
	chmod 755 debian/deepin-terminal/usr/bin/deepin-terminal
	chrpath --delete debian/deepin-terminal/usr/bin/deepin-terminal
	
override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l/usr/lib

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DAPP_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
